﻿#Region "FileHeader"
#If False Then
StyleControls(frm) geht rekursiv das ganze Form durch, und stellt an DGVs und dgv-Columns ein paar Sachen ein, sodass eine einheitliche Optik (Style) entsteht, ohne dass ich im Designer in 4 Grids jeweils alle diese Einstellungen händisch tätigen müsste.
Dabei kommt das mitte Decimal-Spalten garnet zur Ausführung aber als Demo lassichs drinne
#End If '-- Options, Imports
#End Region 'FileHeader

Public Class ControlStyling

   Public Shared Sub StyleControls(frm As Form)
      Dim getChilds As Func(Of Control, IEnumerable) = Function(ctl) ctl.Controls '.Controls
      For Each ctl In getChilds.All(frm)
         Dim dgv = TryCast(ctl, DataGridView)
         If dgv.NotNull Then
            Dim tbl = DirectCast(dgv.DataSource, BindingSource).DataTable
            For Each dgvCol As DataGridViewColumn In dgv.Columns
               Dim dataCol = tbl.Columns(dgvCol.DataPropertyName)
               If dataCol.DataType = GetType(Decimal) Then ' Decimal-Spalten rechtsbündig und als Währung stylen
                  With dgvCol.DefaultCellStyle
                     .Alignment = DataGridViewContentAlignment.MiddleRight
                     .Format = "c"
                     .Font = New Font("Courier New", If(.Font, If(dgv.DefaultCellStyle.Font, dgv.Font)).Size)
                  End With
               End If
            Next
            dgv.RowHeadersWidth = 25
            dgv.Attach.UnFocusedSelectionColor()      ' Das DGV mit dem Focus wird durch stärkere SelectionColor hervorgehoben
            dgv.CellBorderStyle = DataGridViewCellBorderStyle.None
            AddHandler dgv.KeyDown, AddressOf DatagridViewBehavior.DefaultValueOnDelete_KeyDown  ' die Entfernen-Taste schreibt direkt den Default-Value in die Zelle, ohne den Edit-Modus zu bemühen. Kann auch mehrere Zellen gleichzeitig leeren - wie Excel
         End If
         Dim tb = TryCast(ctl, TextBox)
         If tb.NotNull Then
            ' man kann hier auch andere Controls stylen, nicht nur DGV
         End If
      Next
   End Sub

End Class
