﻿#Region "FileHeader"
#If False Then
FigureDts hat recht vielfältige und aufwändige Interaktion mit dem Control, wo die Figuren zu zeichnen sind, dem "Canvas". Indem ich mir das Canvas hereinreichen lasse verstosse ich bewusst gegen die Trennung von Daten und Oberfläche.
Dadurch spare ich große Mengen sog. "Glue-Codes".
Also statt im Form Canvas - Mouse-Down/-Move/-Up und Paint zu verarbeiten und jeweils iwas im Dataset aufrufen, und umgekehrt auch vom Dataset Invalidierungs-Anforderungen zu empfangen und ans Canvas zu leiten, reiche ich einfach das Canvas komplett ins Dataset, und dort findet dann die Grafik in einer dafür vorgesehenen partialen Klasse statt - nämlich in dieser hier.
Gezeichnet werden Figures und Grips - das sind die Eckpunkte, die kann man ziehen, und so die Figur verändern.
Auch die ganze Figur kann man verschieben.

Bei Grafik-Datenverarbeitung tritt zum üblichen "Current" oft das "Hovered" hinzu - eine Vorstufe des Current. Also anwählbare Objekte "hovern" beim Überfahren mit der Maus, um Selectablität anzuzeigen. Indem der User auf ein hovertes Objekt klickst macht er es zum "Current".
Beides - hover und current - sind eiglich nicht Zustände einzelner Objekte, sondern sind einer Objekt-Gesamtheit zugeordnet.
Also dass zB eine Figure selected ist, ergibt sich daraus, dass sie identisch ist mit dem einzigen SelectedItem aller Figures.
Viele implementieren das falsch rum und speichern in jedem Item, ob es selected ist. Und wenn sie dann das SelectedItem abrufen wollen, müssen sie eine Suche durch alle Items durchführen. 

Beide - hover und current - müssen ein spezifisches Markup des Objekts ausführen - hier das Objekt wird einfach mit verschiedenen Stiften gemalt.

Also ich habe 4-faches Markupping: FigureHover, FigureSelect, GripHover, GripSelect.
Bei MousMove ohne Drag werden die Hovers gecheckt, ob ein Grip oder eine Figure unter der Maus ist. Bei einem Grip ist gleichzeitig auch eine Figure unter der Maus, aber Grips sind vorrangig - also entweder Grip oder Figure.
Im MouseDown wird dann das gehoverte Objekt selected. Ists ein Grip, so wird die zugehörige Figure mit-selected - hier unterscheiden sich Hover-Logik und Select-Logik: Hovern kann anwendungsweit nur 1 Objekt, Selecten können 2, nämlich eine Figure und ein Grip. Ist garnix gehovert, werden die Selections gelöscht.
Im MouseDown wird auch der DragOffset gesetzt, wenn was selected wurde.
Bei MouseMove mit gehaltener Taste wird dann gedragt, wenn was selected ist.
Die Markupperei im Einzelnen hab ich in die GraphicMarkup-Klasse verfrachtet. Diese Klasse merkt sich das Objekt (oder Nothing), und wenn es sich ändert kann sie die richtigen Bereiche invalidieren: wo (ggfs) das vorherige war, und wo (ggfs) jetzt das neue ist. Und kann auch die ZeichenRoutine der Objekte aufrufen, mit dem richtigen Stift.
Das Invalidieren eines Bereiches lässt ja kurz darauf das Paint-Event feuern, wo dann neu zu malen ist. Dieses Malen findet hier in 5 Stufen statt:
1+2) gehovertes malen - mittm _HoverPen: Figure und Grip, 3) alle Figuren normal malen (ausser die selectete) - mittm jeweiligen Pen, 4+5) selected malen - mittm jeweiligen SelectedPen: Figure und Grip.
Da Grip und Figure gänzlich verschiedene Klassen sind, muss man die Markup-Objekte aufwändig initialisieren - man muss 4 verschiedene Delegaten angeben, damit das Markup weiß, wie was vom Objekt aufzurufen ist: 
1) GetPen, damit das Markup den Stift abrufen kann, 2) GetBounds, damit das Markup das umschließende Rechteck des Objekts abrufen kann, 3) Invalidate, damit das Objekt invalidiert werden kann (mit Bounds), 4) Draw, damit das Objekt gezeichnet werden kann (mit Pen) 
Ein Select-Markup derselben Objekt-Klasse unterscheidet sich vom Hover-Markup nur durch ein anderes GetPen, damit es anders zeichnet, und auch die Bounds anders bestimmt, denn die Strichbreite muss mit eingehen.
Daher brauche ich nur einmal richtig zu initialisieren, und beim 2. GraphicMarkup kann ich den Copy-Konstruktor verwenden, und brauch dann nur noch das GetPan zu ändern.
#End If '-- Options, Imports
Imports System.Drawing.Drawing2D
#End Region 'FileHeader

Partial Class FigureDts

   Private _FigureHover As New GraphicMarkup(Of FigureRow) With {
      .GetPen = Function(rw) _HoverPen,
      .GetBounds = Function(rw) rw.Bounds,
      .Invalidate = AddressOf Invalidate,
      .Draw = Sub(rw, g, pen) rw.Draw(g, pen)}
   Private WithEvents _FigureSelect As New GraphicMarkup(Of FigureRow)(_FigureHover) With {.GetPen = Function(rw) rw.SelectedPen}
   Public ReadOnly GripHover As New GraphicMarkup(Of GripRow) With {
      .GetPen = Function(rw) _HoverPen,
      .GetBounds = Function(rw) rw.Bounds,
      .Invalidate = AddressOf Invalidate,
      .Draw = Sub(rw, g, pen) rw.Draw(g, pen)}
   Private WithEvents _GripSelect As New GraphicMarkup(Of GripRow)(GripHover) With {.GetPen = Function(rw) rw.FigureRow.SelectedPen}

   Private _ActionWhenCanvasPresent As Action

   Private WithEvents _Canvas As Control
   Public Property Canvas() As Control
      Get
         Return _Canvas
      End Get
      Set(ByVal value As Control)
         If _Canvas Is value Then Return
         _Canvas = value
         If _ActionWhenCanvasPresent.NotNull Then _ActionWhenCanvasPresent() : _ActionWhenCanvasPresent = Nothing
      End Set
   End Property


   Private Shared _HoverPen As New Pen(Color.Silver, 10) With {.LineJoin = LineJoin.Round}

   Private _DragOffset As Vector = Vector.MinValue

   Private Sub Canvas_MouseDown(sender As Object, e As MouseEventArgs) Handles _Canvas.MouseDown
      If e.Button <> MouseButtons.Left Then Return
      'Grip vorrangig selecten
      _GripSelect.Item = GripHover.Item
      If Not _GripSelect.HasMarkup Then _FigureSelect.Item = _FigureHover.Item
      If _FigureSelect.HasMarkup Then GripHover.ClearMarkup() : _FigureHover.ClearMarkup() 'bei Selection darf nix hovern
      'ggfs. DragOffset bestimmen, für Grip oder für Figure
      If _GripSelect.HasMarkup Then : _DragOffset = _GripSelect.Item.Location - e.Location
      ElseIf _FigureSelect.HasMarkup Then : _DragOffset = _FigureSelect.Item.Location - e.Location
      End If
      OptimizePerformance(True)
   End Sub

   Private Sub OptimizePerformance(value As Boolean)
#If False Then
bei Figure-Dragging ist das ständigen Ändern der Figure-Location in zweifacher Hinsicht Performance-kritisch:
1) Durch einen Dataset- oder BindingSource-Bug feuert bei jeder Figure-Location-Änderung die untergeordnete Grip-BindingSource ihr ListChanged, mit ListChangtype.Reset, also das komplette DGV wird neu befüllt! Obwohl an den Grips nicht die Spur geändert wurde!
2) Die Änderung einer Location ändert 2 Werte (X, Y). Die Business-Logic würde jedesmal aufwändig die Grafik aktualisieren. Das ist optimiert, indem die Logik während einer Location-Änderung suspendiert wird. Folgt die nächste Bremse auf dem Fusse: diese Suspendierung wird ins Output-Fenster geloggt, was noch länger dauert. Also wird zusätzlich das Loggen der Suspendierung auch suspendiert. (Das Suspendieren des Loggens des Suspendierens wird natürlich geloggt)
Klar soweit?
Ausserdem suspendiere ich das Loggen der Suspendierung, denn fürs Setzen der Figure-/Grip- Locations-Property wird auch immer suspendiert, und wenn man da jede Suspendierung logt, verkehrt sich der Sinn der Suspendierung ins Gegenteil.
#End If
      If _GripSelect.HasMarkup Then 'Grip-Dragging optimieren
         If value Then : Grip.Attach.LogSuspend.Enter()
         Else : Grip.Attach.LogSuspend.Exit()
         End If
      ElseIf _FigureSelect.HasMarkup Then 'Figure-Dragging optimieren
         If value Then
            Figure.Attach.LogSuspend.Enter()
            Grip.Attach.BeginSuspend(DataTableAttach.Suspend.BindingSources)
         Else
            Grip.Attach.EndSuspend()
            Figure.Attach.LogSuspend.Exit()
         End If
      End If
   End Sub

   Private Sub Canvas_MouseUp(sender As Object, e As MouseEventArgs) Handles _Canvas.MouseUp
      If e.Button = MouseButtons.Left Then OptimizePerformance(False)
   End Sub

   Private Sub Canvas_MouseMove(sender As Object, e As MouseEventArgs) Handles _Canvas.MouseMove
      If e.Button = MouseButtons.Left Then
         DragIfSelectionAvailable(e.Location)
      Else
         CheckHover(e.Location)
      End If
   End Sub

   Private Sub DragIfSelectionAvailable(pt As Point)
      If _GripSelect.HasMarkup Then
         _GripSelect.Item.Location = _DragOffset + pt
      ElseIf _FigureSelect.HasMarkup Then
         _FigureSelect.Item.Location = _DragOffset + pt
      End If
   End Sub

   Private Sub CheckHover(pt As Point)
      Dim figures = Layer.GetVisibleFigures
      Dim gripHov = figures.SelectMany(Function(rw) rw.GetGripRows).FirstOrDefault(Function(rw) rw.Contains(pt))
      GripHover.Item = gripHov
      Dim figHov = If(gripHov.NotNull, Nothing, figures.FirstOrDefault(Function(rw) rw.Contains(pt)))
      _FigureHover.Item = figHov
   End Sub

   Private Sub ResetAllGrafic()
      Dts._Canvas.Invalidate()
      CheckHover(_Canvas.PointToClient(Cursor.Position))
      _FigureSelect.ClearMarkup() : _GripSelect.ClearMarkup()
   End Sub

   Private Sub Canvas_Paint(sender As Object, e As PaintEventArgs) Handles _Canvas.Paint
      Dim g = e.Graphics
      _FigureHover.TryDraw(g)
      GripHover.TryDraw(g)
      For Each fig In Layer.GetVisibleFigures
         If fig IsNot _FigureSelect.Item Then fig.Draw(g)
      Next
      _FigureSelect.TryDraw(g)
      _GripSelect.TryDraw(g)
   End Sub

   Private Sub Invalidate(bounds As Rectangle, pen As Pen)
      Dim padding = CInt(Math.Ceiling(pen.Width) / 2) + 1
      bounds.Inflate(padding, padding)
      _Canvas.Invalidate(bounds)
   End Sub

End Class
