﻿#Region "FileHeader"
#If False Then
Hier Logik, die allen Tabellen übergeordnet ist, also Initialisierung und Befüllung des ganzen Datasets.

Dts_Initialized(): 
Im Desingmode oder wenn Dts bereits zugewiesen ist wird nicht initialisiert.
Dann Dts zuweisen - das ist Public Shared, ist also fast ein Singleton, der dieses Dataset global verfügbar macht.
Dann eine besondere Art Databinding: Die Figure.Attach.Current - Property wird an _FigureSelect.Item gebunden. 
Figure.Attach.Current ist das Current-Tracking der Figure-DataTable, und _FigureSelect ist der SelectionManager für die Figure-Grafik. Also wenn man im DGV eine FigureRow auswählt, dann hopft auch die Grafik-Anzeige um, und umgekehrt.
Das 2 Binding bindet _GripSelect.Item an Grip.Attach.Current, aber nur unidirektional (.Notify). Also Grafik-Selection lässt das DGV hopfen, aber DGV-Anwahl lässt die Grafik kalt.
Zuletzt Parent-Current-Tracking, also einen Grip als Current zu wählen, wählt automatisch die zugehörige Figure auch current.

Fill():
Erstmal wird alle Logik des ganzen Datasets und angebundener BindingSources deaktiviert.
Dann wird geladen. Und dann werden alle FigureRow.ApplyChanges aufgerufen, wodurch ihr Grafik-Verhalten anhand der geladenen Daten eingerichtet wird.
#End If '-- Options, Imports
#End Region 'FileHeader

Partial Class FigureDts

   Public Shared Dts As FigureDts

   Private Sub Dts_Initialized(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Initialized
      If System.ComponentModel.MyDesignMode.True OrElse Dts.NotNull Then Return
      Dts = Me
      Figure.Attach.Property("Current").Synchronisize(_FigureSelect, "Item", Function(rw As DataRow) DirectCast(rw, FigureRow))
      _GripSelect.Property("Item").Notify(Grip.Attach, "Current")
      Grip.SetParentNotifications(Figure, Layer)
   End Sub

   Public Sub Fill()
      Adapter.Fill({})
      _ActionWhenCanvasPresent = Sub() Figure.ForEach(Sub(rw) rw.ApplyChanges())
      If Canvas.NotNull Then _ActionWhenCanvasPresent() : _ActionWhenCanvasPresent = Nothing
   End Sub

End Class