﻿'eiglich alles selbsterklärend bzw. ausreichend kommentiert (wenn man das Readme gelesen hat)
Imports System.Drawing.Drawing2D

Partial Class FigureDts
   Partial Class GripDataTable

#Region "Logik-Suspendierung"
      Private WithEvents _Attach As DataTableAttach = Me.Attach
      Private WithEvents _Active As GripDataTable = Nothing
      Private Sub _Attach_Suspending(ByVal sender As Object, ByVal e As DataTableAttach.SuspendingEventArgs) Handles _Attach.Suspending
         e.TriDecide(_Active, Nothing, Me)
      End Sub
#End Region 'Logik-Suspendierung

      Private Sub _Active_ColumnChanging(sender As Object, e As DataColumnChangeEventArgs) Handles _Active.ColumnChanging
         'falls der Grip selected ist, musser invalidiert werden, bevor die Changes in der Row sind.
         If Not Dts._GripSelect.IsMarked(e.Row) Then Return 'hingegen bei unselected wird er ja garnet angezeigt
         With DirectCast(e.Row, GripRow)
            Dts.Invalidate(.Bounds, .FigureRow.SelectedPen)
         End With
      End Sub

      Private Sub _Active_GripRowChanged(sender As Object, e As GripRowChangeEvent) Handles _Active.GripRowChanged
         If e.Action.AndChangeAdd <> 0 Then e.Row.FigureRow.ApplyChanges() ' Figure-Grafik updaten
      End Sub

      Private _DeletingFigure As FigureRow
      Private Sub _Active_GripRowDeleting(sender As Object, e As GripRowChangeEvent) Handles _Active.GripRowDeleting
         'hover / select abschalten, Figur merken
         Dts._GripSelect.ClearMarkup(e.Row)
         Dts.GripHover.ClearMarkup(e.Row)
         _DeletingFigure = e.Row.FigureRow
      End Sub
      Private Sub _Active_GripRowDeleted(sender As Object, e As GripRowChangeEvent) Handles _Active.GripRowDeleted
         _DeletingFigure.ApplyChanges() 'gemerkte Figur rekonstituieren
      End Sub
   End Class

   Partial Class GripRow

      Private Const _Radius As Integer = 5
      Private Shared _rctTemplate As New Rectangle(-_Radius, -_Radius, _Radius * 2, _Radius * 2)

      ''' <summary> das die Zeichnung umschließende Rechteck, bei Stiftbreite 0. Beachte: die tatsächliche Zeichnung ist um die Stiftbreite größer! </summary>
      Public Function Bounds() As Rectangle
         Return _rctTemplate + (Location + FigureRow.Location)
      End Function

      Public Sub Draw(g As Graphics, pen As Pen)
         g.DrawEllipse(pen, Bounds)
      End Sub

      Public Function Contains(pt As Point) As Boolean
         Return Bounds.Contains(pt)
      End Function

      ''' <summary> Location, relativ zur Location der übergeordneten FigureRow </summary>
      Public Property Location As Vector
         Get
            Return New Vector(X, Y)
         End Get
         Set(value As Vector)
            If value = Location Then Return
            If Dts._GripSelect.IsMarked(Me) Then Dts.Invalidate(Bounds, FigureRow.SelectedPen)
            Using Dts.Grip.Attach.BeginSuspend(DataTableAttach.Suspend.NotifyOnly) ' Grip_RowChanged-Event suspendieren
               With value
                  X = .X : Y = .Y ' ansonsten würde dieses 2 _GripRowChanged() auslösen
               End With
            End Using
            FigureRow.ApplyChanges() ' nach Daten-Änderung den Grafik-Zustand aktualisieren, und Anzeige auslösen
         End Set
      End Property

   End Class


End Class
