﻿#Region "FileHeader"
#If False Then
LayerDataTable hat fast gar keine aktive Logik. Einzig bei neuen Rows wird ein NamensVorschlag generiert, und beim Layer-Wechsel wird alle Grafik resetted.
Weiters gibts noch GetVisibleFigures(), aber das ist passive Logik, mit der man vom Layer die Figures abruft, die aktuell zur Ansicht zu bringen sind.

Aber man kann hier den Suspendierungs-Mechanismus gut betrachten - der ist nämlich bei allen Tabellen gleich:
Es wird der Attach dieser Tabelle abgerufen und als WithEvents gemerkt. Der Attach hält recht viel Zusatz-Funktionalität für diese Tabelle bereit, u.a. auch das Suspending-Event. Etwa beim Laden des Datasets wird es dreimal gefeuert, mit je unterschiedlichem Suspend-Zustand:
1) Started, 2) BeforeEnd, 3) Ended
Eine weitere Withevents-Variable ist "_Active", vom Datentyp LayerDataTable.
Im Attach_Suspending entscheidet nun das SuspendingEventArgs selbst, welchen Wert _Active bekommt: Nothing oder die LayerDataTable selbst (Me).
Bei Nothing findet logisch keine _Active-EventVerarbeitung mehr statt - die Logik ist deaktiviert. Betrifft hier nur Layer_TableNewRow().

Also bei Start einer Suspendierung (etwa beim Befüllen) suspendiert .TriDecide() die Logik, indem es _Active auf Nothing setzt.
Bei BeforeEnd tut es garnix, aber bei Ended re-aktivierts natürlich die Logik wieder, indem es _Active wieder auf die DataTable selbst setzt.
Übrigens logge ich die Suspendierungen aller Tabellen im Debug-Fenster. Dabei werden SuspendStatus, SuspendLevel und die betroffene Tabelle geloggt.
#End If '-- Options, Imports
#End Region 'FileHeader

Partial Class FigureDts

   Partial Class LayerDataTable

      Private WithEvents _Attach As DataTableAttach = Me.Attach
      Private WithEvents _Active As LayerDataTable = Nothing
      Private Sub _Attach_Suspending(ByVal sender As Object, ByVal e As DataTableAttach.SuspendingEventArgs) Handles _Attach.Suspending
         e.TriDecide(_Active, Nothing, Me)
      End Sub

      Private Sub Layer_TableNewRow(sender As Object, e As DataTableNewRowEventArgs) Handles _Active.TableNewRow
         With DirectCast(e.Row, LayerRow)
            .Name = "Layer" & -.ID
         End With
      End Sub
      Private Sub LayerAttach_CurrentChanged(sender As Object, e As EventArgs) Handles _Attach.CurrentChanged
         Dts.ResetAllGrafic()
      End Sub

      Public Function GetVisibleFigures() As FigureRow()
         Dim curr = Current()
         Return If(curr.Null, {}, curr.GetFigureRows)
      End Function

   End Class
   Partial Class LayerRow


   End Class

End Class
