﻿Imports System.Text.RegularExpressions

Public Class Uniquifier : Inherits Dictionary(Of String, Integer)

   Private Shared _rgxLastDigits As New Regex("\d+$", RegexOptions.RightToLeft)

   ''' <summary> appends a number at baseword, to ensure, that its unique in the previousUniques-List  </summary> 
   Public Shared Function Uniquify(baseWord As String, previousUniques As IEnumerable(Of String)) As String
      Dim mt = _rgxLastDigits.Match(baseWord)
      If mt.Success Then baseWord = baseWord.Substring(0, mt.Index)
      Dim i = If(mt.Success, Integer.Parse(mt.Value), 0)
      For Each wrd In previousUniques
         mt = _rgxLastDigits.Match(wrd)
         If mt.Success Then wrd = wrd.Substring(0, mt.Index)
         If wrd = baseWord Then i = Math.Max(i, Integer.Parse(mt.Value))
      Next
      Return baseWord & i + 1
   End Function

   ''' <summary> appends a number at baseword, to ensure, that its unique in this instance of Uniquifier </summary> 
   Default Public Overloads ReadOnly Property Item(baseword As String) As String
      Get
         baseword = _rgxLastDigits.Replace(baseword, "")
         Dim i = 0
         If TryGetValue(baseword, i) Then i += 1
         MyBase.Item(baseword) = i
         Return baseword & i
      End Get
   End Property
   ''' <summary> appends a number at baseword, to ensure, that its unique in this instance of Uniquifier </summary> 
   Default Public Overloads ReadOnly Property Item(baseword As String, ParamArray basewordSegments() As String) As String
      Get
         Return Item(baseword & String.Concat(basewordSegments))
      End Get
   End Property
End Class
