﻿Imports System.Data.Common, System.Diagnostics

Public Class frmDataBaseViewer

   Private _SchemaNames As New List(Of String)
   Private _TableNames As New List(Of String)
   Private _Con As DbConnection
   Private _Factory As DbProviderFactory

   Public Sub New()
      InitializeComponent()
      'show All DbProviderFactories when opened without parameters
      Grid.DataSource = DbProviderFactories.GetFactoryClasses
   End Sub

   Public Sub New(ByVal fct As DbProviderFactory, ByVal ParamArray sCon() As String)
      InitializeComponent()
      _Factory = fct
      _Con = fct.CreateConnection
      _Con.ConnectionString = String.Concat(sCon)
      Text = fct.GetType.Namespace.LastRightCut(".").And(": ", _Con.ConnectionString)
      _Con.Open()
      Dim generalSchema = _Con.GetSchema()
      _SchemaNames.AddRange(From rw In generalSchema Select Name = rw(0).ToString)
      Grid.DataSource = generalSchema
      Try
         Dim tableSchema = _Con.GetSchema("Tables")
         _TableNames.AddRange(From rw In tableSchema Select Name = rw("TABLE_NAME").ToString)
         tableSchema.Dispose()
      Catch ex As Exception
         Debug.WriteLine("Failed: " & ex.Message)
      End Try
      _Con.Close()
      lstSchema.DataSource = _SchemaNames
      lstTable.DataSource = _TableNames
      AddHandler lstSchema.SelectedIndexChanged, AddressOf DbTable_SelectedIndexChanged
      AddHandler lstTable.SelectedIndexChanged, AddressOf DbTable_SelectedIndexChanged
   End Sub

   Private Sub DbTable_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs)
      If DirectCast(sender, ListBox).SelectedIndex < 0 Then Return
      Dim tb = TryCast(Grid.DataSource, DataTable)
      tb.Dispose()
      Dim dtStart = Date.Now
      _Con.Open()
      Debug.WriteLine(Date.Now.Subtract(dtStart).ToString)
      Select Case True
         Case sender Is lstSchema
            Dim schema = _SchemaNames(lstSchema.SelectedIndex)
            Dim msg = "Connection.GetSchema(""" & schema & """)"
            Debug.Write(msg & "    ")
            Try
               Grid.DataSource = _Con.GetSchema(schema)
               Debug.WriteLine("")
            Catch ex As Exception
               Debug.WriteLine("Failed: " & ex.Message)
               MessageBox.Show(msg & " konnte nicht ausgeführt wern")
            End Try

         Case sender Is lstTable
            tb = New DataTable
            Dim sTable = _TableNames(lstTable.SelectedIndex)
            Using adp = _Factory.CreateDataAdapter, cmd = _Factory.CreateCommand
               adp.SelectCommand = cmd
               cmd.Connection = _Con
               cmd.CommandText = "Select * from `" & sTable & "`"
               Debug.Write(cmd.CommandText & "    ")
               Try
                  adp.Fill(tb)
                  Debug.WriteLine("")
               Catch ex As Exception
                  cmd.CommandText = "Select * from [" & sTable & "]"
                  Debug.Write(cmd.CommandText & "    ")
                  Try
                     adp.Fill(tb)
                     Debug.WriteLine("")
                  Catch ex2 As Exception
                     Debug.WriteLine("Failed: " & ex2.Message)
                     MessageBox.Show("""" & cmd.CommandText & """:  Abfrage konnte nicht ausgeführt wern")
                  End Try
               End Try
               Grid.DataSource = tb
            End Using
      End Select
      _Con.Close()
   End Sub

End Class

