﻿#Region "FileHeader"
#If False Then ' -------------- FileDescription --------------
DatagridView with ButtonColumns, which open OpenfileDialogs or Inputbox and trigger some data-processing around the edited Project
#End If
' -------------- Imports & Options --------------------
Imports DbGenerator.DbGeneratorDts
Imports System.IO
Imports System.Text.RegularExpressions
#End Region 'FileHeader

Public Class uclProjects

   Private _rgxInString As New Regex("(?<="")[^""]*(?="")")

   Private Sub ProjectDataGridView_CellContentClick(sender As Object, e As DataGridViewCellEventArgs) Handles ProjectDataGridView.CellContentClick
      Dim rwPj = srcProject.At(Of ProjectRow)(e.RowIndex)
      If rwPj.Null Then Return
      Select Case e.ColumnIndex
         Case clmBtDataset.DisplayIndex 'select Dataset-File
            With Ofd
               .Filter = "Dataset|*.xsd"
               If rwPj.IsDatasetNull Then
                  .FileName = ""
               Else
                  .FileName = rwPj.Dataset
                  .InitialDirectory = Path.GetDirectoryName(.FileName)
               End If
               If .ShowDialog <> Windows.Forms.DialogResult.OK Then Return
               rwPj.Dataset = .FileName
            End With

         Case clmBtDatabase.DisplayIndex 'select Database-File, and derive Connectionstring from that
            With Ofd
               .Filter = "Database-Files|".And(";".Between( _
                  From rwP In DbGeneratorDts.Provider.All Where Not rwP.IsFileExtensionNull
                  From xt In rwP.FileExtension.Split("|"c) Select "*" & xt), "|all Files|*.*")
               Dim mt = _rgxInString.Match(rwPj.ConnectionString)
               If mt.Success Then
                  .FileName = mt.Value
                  .InitialDirectory = Path.GetDirectoryName(.FileName)
               Else
                  .FileName = ""
               End If
               If .ShowDialog <> Windows.Forms.DialogResult.OK Then Return
               Dim ext = Path.GetExtension(.FileName).ToLower
               Dim rwProv = Aggregate rwP In DbGeneratorDts.Provider.All Into _
                  FirstOrDefault(Not rwP.IsFileExtensionNull AndAlso rwP.FileExtension.Split("|"c).Any(Function(splt) splt.ToLower = ext))
               If rwProv.Null Then Return
               rwPj.ProviderRow = rwProv
               rwPj.ConnectionString = rwProv.ConnectionPattern.Replace("?", .FileName)
            End With

         Case clmBtConnectionString.DisplayIndex 'input Connectionstring directly
            Dim s = Microsoft.VisualBasic.InputBox("ConnectionString eingeben", DefaultResponse:=rwPj.ConnectionString)
            If s = "" Then Return
            rwPj.ConnectionString = s

         Case Else : Return
      End Select
      Try
         rwPj.TryEnsureMappings() 'load Provider-Settings from Db (if currently isnt present)
         If Not rwPj.IsDatasetNull Then rwPj.CreateColumnMappings() 'parse DataColumns from Dataset-File and associate them with Provider-Mappings
      Catch ex As Exception
         If MessageBox.Show(ex.Message.And2("\n\nwanna see StackTrace?"), "Error while reading Database-Information", MessageBoxButtons.YesNo, MessageBoxIcon.Error) = DialogResult.Yes Then MessageBox.Show(ex.StackTrace)
      End Try
      If rwPj.RowState = DataRowState.Detached Then srcProject.EndEdit()
      srcProject.ResetBindings(False)
   End Sub

   Private Sub ProjectDataGridView_CellFormatting(sender As Object, e As DataGridViewCellFormattingEventArgs) Handles ProjectDataGridView.CellFormatting
      Dim rw = ProjectDataGridView.DataRow(Of ProjectRow)(e.RowIndex)
      If rw.Null Then Return
      Select Case e.ColumnIndex
         Case clmBtDataset.DisplayIndex 'although the datacolumn holds the fullpath, display only the filename
            If e.Value Is Nothing Then Return
            e.Value = Path.GetFileName(e.Value.ToString)

         Case clmBtDatabase.DisplayIndex 'try derive filename from Connectionstring
            If e.Value Is Nothing Then Return
            Dim mt = _rgxInString.Match(e.Value.ToString)
            e.Value = ""
            If mt.Success Then
               With New FileInfo(mt.Value)
                  If .Exists Then e.Value = .Name
               End With
            End If
         Case Else : Return
      End Select
      e.FormattingApplied = True
   End Sub

   Private Sub srcProject_CurrentChanged(sender As Object, e As EventArgs) Handles srcProject.CurrentChanged
      'set MappingID-DefaultValue to the NullMappingRow of the current Provider.
      Dim rwProj = srcProject.At(Of ProjectRow)()
      If rwProj.Null OrElse rwProj.RowState = DataRowState.Detached Then Return
      DbGeneratorDts.ColumnMapping.MappingIDColumn.DefaultValue = rwProj.ProviderRow.GetMappingRows.First(Function(mp) mp.IsNullRow).ID
   End Sub

End Class
