﻿Imports System.ComponentModel
Imports DbGenerator.DbGeneratorDts

Public Class uclProviderMappings

   Public Sub New()
      InitializeComponent()
      MappingDataGridView.Attach.DrawGroupLines(hideRepeat:=True)
   End Sub

   Private Sub MappingDataGridView_CellPainting(sender As Object, e As DataGridViewCellPaintingEventArgs) Handles MappingDataGridView.CellPainting
      'markup Preferred-Column, deletable DbNames and - if ParamNames present: ParamDefaultValues
      If Not e.RowIndex.IsBetween(0, srcMappings.Count) Then Return
      Dim rw = srcMappings.At(Of MappingRow)(e.RowIndex)
      Select Case e.ColumnIndex
         Case clmDbName.DisplayIndex : If Not rw.CanDelete Then Return
         Case clmPreferred.DisplayIndex
         Case clmParamDefaultValues.DisplayIndex : If rw.ParamNames = "" Then Return
         Case Else : Return
      End Select
      If (e.State And DataGridViewElementStates.Selected) <> 0 Then Return
      e.Graphics.FillRectangle(Brushes.AliceBlue, e.CellBounds)
      e.Paint(e.CellBounds, DataGridViewPaintParts.All Xor DataGridViewPaintParts.Background)
      e.Handled = True
   End Sub

   Private Sub Button_Click(sender As Object, e As EventArgs) Handles btEditMapping.Click, btDeleteMapping.Click
      Select Case True
         Case sender Is btEditMapping : srcMappings.EditCurrent(Of dlgMapping)()
         Case sender Is btDeleteMapping : srcMappings.At(Of MappingRow).Delete()
      End Select
   End Sub

   Private Sub srcProvider_CurrentChanged(sender As Object, e As EventArgs) Handles srcProvider.CurrentChanged
      'init Quoting-Functions depending on the current Provider
      With srcProvider.At(Of ProviderRow)()
         If .NotNull AndAlso Not .IsQuotesNull Then InitQuotes(.Self.Quotes)
      End With
   End Sub
End Class
