﻿Namespace System.ComponentModel

   Public Class ComponentProperty(Of Tcomp As IComponent, T) : Inherits Dictionary(Of Tcomp, T)

      Public Class EvArgs : Inherits EventArgs
         Public Component As Tcomp, Attached As T
         Public Sub New(Component As Tcomp, Attached As T)
            Me.Component = Component
            Me.Attached = Attached
         End Sub
      End Class
      Public Shared Event Attached As EventHandler(Of EvArgs)
      Private ReadOnly _Init As Func(Of Tcomp, T)

      Private Sub cmp_Disposed(s As Object, e As EventArgs)
         Remove(DirectCast(s, Tcomp))
      End Sub

      Public Sub New(Optional init As Func(Of Tcomp, T) = Nothing)
         _Init = init
      End Sub
      Public Shadows Sub Add(cmp As Tcomp, itm As T)
         MyBase.Add(cmp, itm)
         AddHandler cmp.Disposed, AddressOf cmp_Disposed
         RaiseEvent Attached(Me, New EvArgs(cmp, itm))
      End Sub
      Public Shadows Function Remove(cmp As Tcomp) As Boolean
         Remove = MyBase.Remove(cmp)
         If Remove Then RemoveHandler cmp.Disposed, AddressOf cmp_Disposed
      End Function

      Default Public Shadows Property Item(cmp As Tcomp) As T
         Get
            Dim ret As T = Nothing
            If Not MyBase.TryGetValue(cmp, ret) Then
               If _Init.NotNull Then ret = _Init(cmp)
               Add(cmp, ret)
            End If
            Return ret
         End Get
         Set(value As T)
            If Not MyBase.ContainsKey(cmp) Then AddHandler cmp.Disposed, AddressOf cmp_Disposed : RaiseEvent Attached(Me, New EvArgs(cmp, value))
            MyBase.Item(cmp) = value
         End Set
      End Property

   End Class

End Namespace
