﻿#Region "FileHeader"
#If False Then
wraps an enter- and an exit-Action, which may call configuration- and cleanup-Code. Designingly I abuse the Dispose-Pattern, so you can call ActionFrame.Enter() in an Using-Block, and leaving the bloc will execute the exit-Action (eg. cleanup something)
Nested .Enter()-calls are no problem and moreover ActionFrames can be combined in order to do Child-Configurations/-Cleanups
Alternatively to enter- exit-Action you can initialize it with an Action(of Boolean), which will be called back on Enter with true and on Exit with false.
#End If '-- Options, Imports
#End Region 'FileHeader



Namespace System
   ''' <summary>
   ''' wraps an enter- and an exit-Action, which may call configuration- and cleanup-Code. Calling .Enter() within an Using-Block the leaving of the Block will execute the exit-Action (cleanup-Code)
   ''' </summary>
   Public Class ActionFrame : Implements IDisposable

      Protected _enter As Action, _exit As Action
      Protected _Switch As Action(Of Boolean)
      Protected _level As Integer = 0
      ''' <summary> usually better call .Enter() within an using-block, to make shure Enter and Exit are called propperly </summary>
      Public Sub ExecuteEnter()
         _enter()
      End Sub
      ''' <summary> usually better call .Enter() within an using-block, to make shure Enter and  Exit are called propperly </summary>
      Public Sub ExecuteExit()
         _exit()
      End Sub
      Public ReadOnly Property Level As Integer
         Get
            Return _level
         End Get
      End Property
      Public Shared Function ExitWith([exit] As Action) As IDisposable
         Return (New ActionFrame(Nothing, [exit])).Enter
      End Function
      Public Sub New(ParamArray childFrames As ActionFrame())
         For Each chld In childFrames : Add(chld) : Next
      End Sub
      Protected Overridable Sub EnterSwitch()
         _Switch(True)
      End Sub
      Protected Overridable Sub ExitSwitch()
         _Switch(False)
      End Sub
      Public Sub New(switch As Action(Of Boolean))
         _Switch = switch
         Add(AddressOf EnterSwitch, AddressOf ExitSwitch)
      End Sub
      Public Sub New(enter As Action, [exit] As Action)
         Add(enter, [exit])
      End Sub
      Private Sub EnterCore()
         _level += 1
         If _level = 1 AndAlso _enter IsNot Nothing Then _enter()
      End Sub
      Public Sub IncreaseLevel([step] As Integer)
         Select Case [step]
            Case 1 : EnterCore()
            Case 0
            Case -1 : [Exit]()
            Case Else : Throw Me.Exception("only the steps -1, 0, 1 are valid")
         End Select
      End Sub
      Public Function Enter() As IDisposable
         EnterCore()
         Return Me
      End Function
      <Obsolete("use Exit() or better dispose by IDisposable-Interface instead")> _
      Public Sub Dispose()
         Throw Me.Exception("Obsolete - use Exit() or better dispose by IDisposable-Interface instead")
      End Sub
      Public Sub [Exit]() Implements IDisposable.Dispose
         _level -= 1
         Select Case _level
            Case -1
               Throw Me.Exception("cannot set Level < 0!")
            Case 0
               _exit()
         End Select
      End Sub
      ''' <summary>
      ''' Zufügen weiterer ActionFrame läßt baumartige Ablauf-Strukturen entstehen
      ''' </summary>
      Public Sub Add(child As ActionFrame)
         Add(AddressOf child.EnterCore, AddressOf child.Exit)
      End Sub
      Public Sub Add(enter As Action, [exit] As Action)
         enter.Handles(_enter)
         [exit].Handles(_exit)
      End Sub
   End Class


   Public Class ConditionalActionFrame : Inherits ActionFrame
      Protected ToToggle As Boolean
      Protected _condition As Func(Of Boolean), _innerEnter As Action, _innerExit As Action
      Public Sub New(condition As Func(Of Boolean), switch As Action(Of Boolean))
         MyBase.New(switch)
         _condition = condition
         'MyBase.Add(AddressOf TryEnter, AddressOf TryExit)
      End Sub
      Public Sub New(condition As Func(Of Boolean), enter As Action, [exit] As Action)
         _condition = condition
         _innerEnter = enter
         _innerExit = [exit]
         MyBase.Add(AddressOf TryEnter, AddressOf TryExit)
      End Sub
      Protected Overrides Sub EnterSwitch()
         ToToggle = _condition()
         If ToToggle Then MyBase.EnterSwitch()
      End Sub
      Protected Overrides Sub ExitSwitch()
         If ToToggle Then MyBase.ExitSwitch()
      End Sub
      Private Sub TryEnter()
         ToToggle = _condition()
         If ToToggle Then _innerEnter()
      End Sub
      Private Sub TryExit()
         If ToToggle Then _innerExit()
      End Sub
   End Class

End Namespace
