﻿Imports MySqlTest.NorthWindDts

Public Class frmMySqlTest

   Private _TimeRanges As Integer() = New Integer() {9999, 1, 2, 3, 6, 9, 12}

   Public Sub New()
      InitializeComponent()
      Me.AlignOnTop()
      cmbOrderRange.DataSource = _TimeRanges
      Dim adp = New DatasetAdapter( _
         MySql.Data.MySqlClient.MySqlClientFactory.Instance, _
         "server=dd17626.kasserver.com;user id=unKnown;password=unKnown;persist security info=True;database=d0197ea0", _
         ConflictOption.OverwriteChanges)
      Me.NorthWindDts.Adapter(adp).Register(Me, True)
      Reload()
   End Sub

   Private Sub MenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) _
         Handles ReloadToolStripMenuItem.Click, SaveToolStripMenuItem.Click, TestToolStripMenuItem.Click, btEmpfFilter.Click
      Select Case True
         Case sender Is ReloadToolStripMenuItem : Reload()

         Case sender Is SaveToolStripMenuItem : NorthWindDts.Save(Me)

         Case sender Is btEmpfFilter
            srcKundeBestellung.FilterX("Empfänger LIKE *?*", txtEmpfFilter.Text)
            lbFilter.Text = srcKundeBestellung.Filter

         Case sender Is TestToolStripMenuItem
            Msg("Anzahl Datensaetze: ", NorthWindDts.Tables.Cast(Of DataTable).Sum(Function(tb) tb.Rows.Count))

      End Select
   End Sub

   Private Sub Reload()
      With NorthWindDts
         .Fill(.Kunden, .Artikel)
      End With
   End Sub

   Private Sub SetOrderFilter()
      'wendet einen Filter an, der vonne letzten Bestellung n Monate zurückrechnet
      If cmbOrderRange.SelectedIndex < 0 Then Return
      Dim n = _TimeRanges(cmbOrderRange.SelectedIndex)
      Dim rwLastOrder = srcKundeBestellung.At(Of BestellungenRow)(0)
      If rwLastOrder.Null Then srcKundeBestellung.FilterX("") : Return
      Dim dt = rwLastOrder.Bestelldatum
      srcKundeBestellung.FilterX(cmbOrderRange.SelectedIndex > 0, "Bestelldatum > ?", dt.AddMonths(-n))
      lbFilter.Text = srcKundeBestellung.Filter
   End Sub

   Private Sub Something_Changed(ByVal sender As Object, ByVal e As EventArgs) Handles cmbOrderRange.SelectedIndexChanged, srcKunden.PositionChanged
      SetOrderFilter()
   End Sub

   Private Sub srcKunden_CurrentChanged(sender As System.Object, e As System.EventArgs) Handles srcKunden.CurrentChanged
      Dim rwKunde = srcKunden.At(Of KundenRow)()
      With NorthWindDts
         rwKunde.FillChildTables(.Bestelldetails, .Bestellungen)
      End With

   End Sub
End Class