﻿Imports NorthWind.NorthWindDts
Imports System.Data.OleDb
Imports System.Data.Common

Public Class frmMain

   Private _TimeRanges As Integer() = New Integer() {9999, 1, 2, 3, 6, 9, 12}

   Public Sub New()
      InitializeComponent()
      NorthWindDts.CheckedCategory.Persist(False)

#If True Then   'x86-kompiliert
      Dim adp = New DatasetAdapter( _
         OleDbFactory.Instance, My.Settings.JetOleConnectionString, _
         ConflictOption.OverwriteChanges)
      Me.AlignOnTop.NorthWindDts.Adapter(adp).Register(Me, True)
#ElseIf True Then  'x64-kompiliert
         Dim adp = New DatasetAdapter( _
            OleDbFactory.Instance, My.Settings.AceOleConnectionString, _
            ConflictOption.OverwriteChanges)
         Me.AlignOnTop.NorthWindDts.Adapter(adp).Register(Me, True)
#ElseIf True Then
#End If
      cmbOrderRange.DataSource = _TimeRanges

      Dim Joiner As New Joiner
      Joiner.Add(NorthWindDts.Artikel.KategorieIDColumn)
      Joiner.Add(NorthWindDts.Bestelldetails.BestellIDColumn)
      Joiner.Add(NorthWindDts.Bestelldetails.ArtikelIDColumn)
      Joiner.Add(NorthWindDts.Bestellungen.KundeIDColumn)
      Dbg(Joiner.Sql)

      Reload()
   End Sub

   Private Sub MenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) _
         Handles ReloadToolStripMenuItem.Click, SaveToolStripMenuItem.Click, TestToolStripMenuItem.Click, ReFillStoreToolStripMenuItem.Click
      Select Case True
         Case sender Is ReloadToolStripMenuItem : Reload()
         Case sender Is SaveToolStripMenuItem : NorthWindDts.Save(Me)
         Case sender Is TestToolStripMenuItem : Test()
         Case sender Is ReFillStoreToolStripMenuItem
            Using frm = New frmRefillStore
               frm.ShowDialog(Me)
            End Using
      End Select
   End Sub

   Private Sub SelectLastOrders()
      'NorthWindDts.Bestellungen.Fill("where KundeID=? and Bestelldatum = (select max(Bestelldatum) from Bestellungen where KundeID=?)", "Alfki", "Alfki")
      'NorthWindDts.Bestellungen.Fill("(Bestellungen inner join Kunden on Kunden.KundeID = Bestellungen.KundeID ) where Bestelldatum = (select max(Bestelldatum) from Bestellungen where Bestellungen.KundeID= Kunden.KundeID)")
      NorthWindDts.Bestellungen.Fill(" where Bestelldatum = (select max(Bestelldatum) from Bestellungen as b2 where Bestellungen.KundeID= b2.KundeID)")
      'BestellDetails wären dann im Bestellung.CurrentChanged abzurufen
   End Sub

   Private Sub Test()
      If False Then
      ElseIf True Then
         Dim Joiner As New Joiner
         Joiner.Add(NorthWindDts.Bestelldetails.BestellIDColumn, "ArtikelID=?")
         Joiner.SelfJoin(NorthWindDts.Bestelldetails.BestellIDColumn, "ArtikelID=?")
         Dbg(Joiner.Sql)
         Return
      ElseIf True Then
         Dim Joiner As New Joiner
         Joiner.Add(NorthWindDts.Artikel.KategorieIDColumn)
         Joiner.Add(NorthWindDts.Bestelldetails.BestellIDColumn)
         Joiner.Add(NorthWindDts.Bestelldetails.ArtikelIDColumn)
         Joiner.Add(NorthWindDts.Bestellungen.KundeIDColumn)
         Dbg(Joiner.Sql)
         Return
      ElseIf True Then
         NorthWindDts.Kategorien.Fill("where Kategoriename LIKE ?", "ge%")
         Dim Joiner As New Joiner
         Joiner.Add(" Kategoriename LIKE 'get%'", NorthWindDts.Artikel.KategorieIDColumn)
         NorthWindDts.Artikel.Fill(Joiner.Sql)
      ElseIf True Then
         SelectLastOrders()
         Return
      ElseIf True Then
         ' achtung! zur korrekten Ergebnis-Anzeige muß die dynamische Befüllung auf
         '°Komplettbefüllung umgestellt wern: (in Reload: NorthwindDts.Fill() +
         '°KundenBindingSource_CurrentChanged abhängen)
         Dim joiner As New Joiner()
         ' alle Bestellungen mit Artikel 1 **und** 2
         ' korrekt formuliert: alle Bestellungen, die BestellDetails enthalten, von denen eines
         '°auf Art 1 verweist, **und** ein anneres auf Art 2
         joiner.Add(NorthWindDts.Bestelldetails.BestellIDColumn, "ArtikelID=?")
         joiner.SelfJoin(NorthWindDts.Bestelldetails.BestellIDColumn, "ArtikelID=?")
         NorthWindDts.Bestellungen.Fill(joiner.Sql, 1, 2)

         'kunden ausgeben, die das bestellt haben
         Dbg(" ".Between(From bst In NorthWindDts.Bestellungen Select bst.KundeID))

         ' alle Bestelldetails  dieser Bestellungen
         ' korrekt formuliert: alle BestellDetails, die in Bestellungen enthalten sind, die
         '°BestellDetails enthalten, von denen eines auf Art 1 verweist, und ein anneres auf Art 2
         Dim n = NorthWindDts.Bestellungen.Rows.Count
         joiner.Clear()
         'joiner.SelfJoin("ArtikelID=?", NorthWindDts.Bestelldetails.BestellIDColumn, "ArtikelID=?")
         joiner.SelfJoin(NorthWindDts.Bestelldetails.BestellIDColumn, "ArtikelID=?")
         joiner.SelfJoin(NorthWindDts.Bestelldetails.BestellIDColumn, "ArtikelID=?")
         NorthWindDts.Bestelldetails.Fill(joiner.Sql, 1, 2)
         Return
      ElseIf True Then
         NorthWindDts.Kategorien.Fill("where kategorieID in (?,?)", 1, 4)
      ElseIf True Then
         NorthWindDts.Kategorien.Fill("where mid(Kategoriename, 2, 1)= ?", "e")
      ElseIf True Then
         NorthWindDts.Kategorien.Fill("where KategorieID between ? and ?", 1, 5)
      ElseIf True Then
      End If

      MsgBox(String.Join(vbNewLine, New String() { _
         "Durch diesen Test wurde Kategorien neu befüllt, nicht aber Artikel.", _
         "Daher sind alle Artikel gelöscht, und dadurch auch alle BestellDetails.", _
         "Wenn man nun einen anneren Kunden anwählt, so werden ja dessen Bestellungen nachgeladen, und auch deren Bestelldetails (normale Funktionalität des Progs).", _
         "Aber die nachgeladenen BestellDetails verweisen dann z.T. auf Artikel, dies nicht mehr gibt.", _
         "Folge: Crash.", _
         "Ist ja nur ein test, ob der Sql-Ausdruck funzt.", _
         "", _
         "Dasser funzt, sieht man auf dem 'Artikel'-Tab ;)"}))
   End Sub

   Private Sub Reload()
      With NorthWindDts
         '.Fill()
         .Fill(.Artikel, .Kategorien, .Kunden)
      End With
   End Sub

   Private Sub KundenBindingSource_CurrentChanged(ByVal sender As Object, ByVal e As EventArgs) Handles KundenBindingSource.CurrentChanged
      Dim rwKunde = KundenBindingSource.At(Of KundenRow)()
      If rwKunde.Null Then Return
      With NorthWindDts
         rwKunde.FillChildTables(.Bestelldetails, .Bestellungen)
      End With
      SetOrderFilter()
   End Sub
   
   Private Sub SetOrderFilter()
      'wendet einen Filter an, der vonne letzten Bestellung n Monate zurückrechnet
      If cmbOrderRange.SelectedIndex < 0 Then Return
      Dim n = _TimeRanges(cmbOrderRange.SelectedIndex)
      Dim rwLastOrder = srcKundeBestellung.At(Of BestellungenRow)(0)
      If rwLastOrder.Null Then srcKundeBestellung.FilterX("") : Return
      Dim dt = rwLastOrder.Bestelldatum
      srcKundeBestellung.FilterX(cmbOrderRange.SelectedIndex > 0, "Bestelldatum > ?", dt.AddMonths(-n))
      lbFilter.Text = srcKundeBestellung.Filter
   End Sub

   Private Sub cmbOrderRange_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles cmbOrderRange.SelectedIndexChanged
      SetOrderFilter()
   End Sub

End Class