﻿Imports SqlServerTest.NorthwindDts
Imports System.Data.OleDb
Imports System.Data.SqlClient, System.IO

Public Class frmSqlSrv

   Private _TimeRanges As Integer() = New Integer() {9999, 1, 2, 3, 6, 9, 12}

   Public Sub New()
      InitializeComponent()
      Dim adp = New DatasetAdapter( _
         SqlClientFactory.Instance, _
         "Data Source=.\SQLEXPRESS;AttachDbFilename=..\..\NORTHWND.MDF;Integrated Security=True;User Instance=True".QuotedFullnamed, _
         ConflictOption.OverwriteChanges)
      Me.AlignOnTop.NorthwindDts.Adapter(adp).Register(Me, True)
      cmbOrderRange.DataSource = _TimeRanges
      Reload()
   End Sub

   Private Sub Button_Click(ByVal sender As Object, ByVal e As EventArgs) _
         Handles ReloadToolStripMenuItem.Click, SaveToolStripMenuItem.Click, _
         TestToolStripMenuItem.Click, btAddProduct.Click, btCancelEdit.Click, btDelete.Click
      Select Case True
         Case sender Is ReloadToolStripMenuItem : Reload()

         Case sender Is SaveToolStripMenuItem
            ProductsBindingSource.EndEdit()
            NorthwindDts.Save(Me)

         Case sender Is TestToolStripMenuItem
            NorthwindDts.Customers.Fill("where customerID like ?", "AN%")

         Case sender Is btAddProduct
            With ProductsBindingSource.AddNewX(Of ProductsRow)()
               .SupplierID = 1
            End With

         Case sender Is btCancelEdit : ProductsBindingSource.CancelEdit()

         Case sender Is btDelete : ProductsBindingSource.RemoveCurrent()

      End Select
   End Sub

   Private Sub Reload()
      With NorthwindDts
         .Fill(.Products, .Categories, .Customers)
      End With
   End Sub

   Private Sub CustomersBindingSource_CurrentChanged(ByVal sender As Object, ByVal e As EventArgs) _
         Handles CustomersBindingSource.CurrentChanged
      Dim rw = CustomersBindingSource.At(Of CustomersRow)()
      If rw.Null Then Return
      With NorthwindDts
         rw.FillChildTables(.Orders, .Order_Details)
      End With
      SetOrderFilter()
   End Sub
   
   Private Sub SetOrderFilter()
      If cmbOrderRange.SelectedIndex < 0 Then Return
      Dim n = _TimeRanges(cmbOrderRange.SelectedIndex)
      If NorthwindDts.Orders.Count = 0 Then Exit Sub
      Dim dt = NorthwindDts.Orders.Max(Function(r) r.OrderDate)
      srcCustomerOrder.FilterX(cmbOrderRange.SelectedIndex > 0, "OrderDate > ?", dt.AddMonths(-n))
      lbFilter.Text = srcCustomerOrder.Filter
   End Sub

   Private Sub cmbOrderRange_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles cmbOrderRange.SelectedIndexChanged
      SetOrderFilter()
   End Sub
End Class