﻿#Region "FileHeader"
#If False Then ' -------------- FileDescription --------------
#End If ' -------------- Imports & Options --------------------
#End Region 'FileHeader

Namespace System.Data

   Partial Public Class DataTableAttach
      Public Class DatasetAttach : Implements IDisposable
         Public ReadOnly Dataset As DataSet
         Public ReadOnly RankedAttachs As DataTableAttach()
         Public ReadOnly SuspendConstraints As ConditionalActionFrame

         Public Function TableAttachs(persistance As Persistance) As IEnumerable(Of DataTableAttach)
            Return RankedAttachs.Where(Function(att) 0 <> (att.Persistance And persistance))
         End Function

         Public Sub New(dts As DataSet)
            Dataset = dts
            RankedAttachs = Dataset.GetRankedTables.Select(Function(tb) tb.Attach).ToArray
            For Each att In RankedAttachs
               att._Dataset_Attach = Me
               att._ChildAttachs = att.Table.ChildTables.Select(Function(tb) tb.Attach).ToArray
            Next
            SuspendConstraints = New ConditionalActionFrame( _
                  Function() Dataset.EnforceConstraints, AddressOf SwitchEnforceConstraints)
         End Sub
         Private Sub SwitchEnforceConstraints(suspend As Boolean)
            Dataset.EnforceConstraints = Not suspend
         End Sub

         Friend _SavedCallback As Action
         Friend Sub RegisterSaveCallback(dlg As Action, value As Boolean)
            dlg.RemoveHandler(_SavedCallback)
            If value Then dlg.Handles(_SavedCallback)
         End Sub

         Public Function BeginSuspendAll(Optional what As Suspend = Suspend.TableIndicees) As IDisposable
            Return BeginSuspend(RankedAttachs, what)
         End Function

         Public Function BeginSuspend(attaches As IEnumerable(Of DataTableAttach), what As Suspend) As IDisposable
            Dim isNewGroup = Not RankedAttachs.Any(Function(att) att._GroupSuspended)
            For Each att In attaches
               If isNewGroup Then : att._GroupSuspended = True  ' Flag att as member of this "suspending-group"
               ElseIf Not att._GroupSuspended Then : Throw Me.Exception("cannot add new attaches to existing Suspend-Group")
               End If
               att.BeginSuspend(what)
            Next
            Return Me
         End Function
         Public Sub EndSuspend() Implements IDisposable.Dispose
            Dim suspendeds = RankedAttachs.Where(Function(a) a._GroupSuspended).ToArray
            suspendeds.ForEach(Sub(att) att.RaiseSuspendingEvent(Suspendstate.BeforeEnd, att._Suspend))
            For Each att In suspendeds
               att.EndSuspend()
               att._GroupSuspended = False
            Next
         End Sub

      End Class 'DatasetAttach
   End Class 'DataTableAttach
End Namespace
