﻿Imports System.IO
Imports System.ComponentModel

Namespace System.Data

   Public Class DatasetXmlAdapter : Inherits DatasetAdapterBase

      Public DataFile As FileInfo

      Public Sub New(_Dts As DataSet)
         DataSet = _Dts
#If DEBUG Then
         DataFile = New FileInfo(New DirectoryInfo("..\..\").Combine(_Dts.GetType.Name & ".xml"))
#Else
         DataFile = New FileInfo(New DirectoryInfo(Application.LocalUserAppDataPath).Combine(_Dts.GetType.Name & ".xml"))
#End If
      End Sub

      Protected Overrides Sub _Save(attaches As List(Of DataTableAttach))
         _DataSet.AcceptChanges()
         Using _DataSet.SuspendConstraints
            ReadWriteSelective(FileAccess.Write)
         End Using
      End Sub

      Protected Overrides Sub _Fill(tbls As Collections.Generic.IEnumerable(Of DataTable))
         If tbls.FirstOrDefault.NotNull Then Throw New NotSupportedException( _
               "Bei DatasetOnly werden immer alle Tabellen befüllt - bestimmte Tabellen anzugeben ist sinnlos")
         DataFile.Refresh()
         If DataFile.Exists() Then
            Using _DatasetAttach.BeginSuspendAll
               ReadWriteSelective(FileAccess.Read)
               DataSet.AcceptChanges()
            End Using
         Else
            Msg(String.Concat( _
               "Leider (noch) kein DatenFile vorhanden", Lf, _
               "Sie können aber trotzdem fortfahren, und eines anlegen."))
         End If
      End Sub

      'Protected Overrides Sub _Fill(tbls As Collections.Generic.IEnumerable(Of DataTable))
      '   If tbls.FirstOrDefault.NotNull Then Throw New NotSupportedException( _
      '         "Bei DatasetOnly werden immer alle Tabellen befüllt - bestimmte Tabellen anzugeben ist sinnlos")
      '   DataFile.Refresh()
      '   If DataFile.Exists() Then
      '      For Each att In RankedAttachs : att.BeginSuspend(DataTableAttach.Suspend.TableIndicees) : Next
      '         ReadWriteSelective(FileAccess.Read)
      '         DataSet.AcceptChanges()
      '      For Each att In RankedAttachs : att.EndSuspend() : Next
      '   Else
      '      MsgBox(String.Concat( _
      '         "Leider (noch) kein DatenFile vorhanden", ControlChars.Lf, _
      '         "Sie können aber trotzdem fortfahren, und eines anlegen."))
      '   End If
      'End Sub

      Private Sub ReadWriteSelective(access As FileAccess)
         Dim skips = _DataSet.Tables.Cast(Of DataTable).ToList(Function(tb) tb.Attach.Persistance = Persistance.No)
         'Dim skips = RankedAttachs.ToList(Function(tb) tb.Persistance = Persistance.No)
         If skips.Any Then
            Using clone = New DataSet, rd = New StringReader(_DataSet.GetXmlSchema)
               clone.ReadXmlSchema(rd)
               If access = FileAccess.Read Then
                  ReadWrite(clone, DataFile, FileAccess.Read)
                  MergeSelective(clone, skips, FileAccess.Read)
               Else
                  MergeSelective(clone, skips, FileAccess.Write)
                  ReadWrite(clone, DataFile, FileAccess.Write)
               End If
            End Using
         Else
            ReadWrite(_DataSet, DataFile, access)
         End If
      End Sub

      Private Sub MergeSelective(clone As DataSet, skips As List(Of Boolean), access As FileAccess)
         Dim source = If(access = FileAccess.Read, clone, _DataSet)
         Dim target = If(access = FileAccess.Read, _DataSet, clone)
         For i = 0 To _DataSet.Tables.Count - 1
            If skips(i) Then Continue For
            With target.Tables(i)
               .Clear()
               .Merge(source.Tables(i))
            End With
         Next
      End Sub

      Private Shared Sub ReadWrite(dts As DataSet, fi As FileInfo, access As FileAccess)
         If access = FileAccess.Read Then
            dts.ReadXml(fi.FullName)
         Else
            dts.WriteXml(fi.FullName)
         End If
      End Sub

   End Class

End Namespace