﻿Imports System.Runtime.CompilerServices
Imports System.Reflection
Imports System.ComponentModel
Imports System.Data
Imports System.IO

Namespace System.Windows.Forms
   Public Module FormX

      ''' <summary>dockt das Form am oberern Bildschirmrand, in voller Breite</summary>
      <Extension()> _
      Public Function AlignOnTop(Of T As Form)(frm As T) As T
         AlignOnTop = frm
         If frm.WindowState = FormWindowState.Maximized Then Exit Function
         Dim rct = Screen.PrimaryScreen.WorkingArea
         rct.Height = frm.Height
         frm.StartPosition = FormStartPosition.Manual
         frm.Bounds = rct
      End Function

      ''' <summary>dockt das Form am oberern Bildschirmrand, in voller Breite</summary>
      <Extension()> _
      Public Function AlignOnScreen(Of T As Form)(frm As T, align As ContentAlignment) As T
         AlignOnScreen = frm
         If frm.WindowState = FormWindowState.Maximized Then Exit Function
         frm.StartPosition = FormStartPosition.Manual
         Dim rct = Screen.PrimaryScreen.WorkingArea
         Select Case align
            Case ContentAlignment.TopLeft : rct.Size = frm.Size
            Case ContentAlignment.TopCenter : rct.Height = frm.Height
            Case ContentAlignment.TopRight : rct.X = rct.Right - frm.Width : rct.Size = frm.Size
            Case ContentAlignment.MiddleLeft : rct.Width = frm.Width
            Case ContentAlignment.MiddleCenter : Exit Function
            Case ContentAlignment.MiddleRight : rct.X = rct.Right - frm.Width : rct.Width = frm.Width
            Case ContentAlignment.BottomLeft : rct.Y = rct.Bottom - frm.Height : rct.Size = frm.Size
            Case ContentAlignment.BottomCenter : rct.Y = rct.Bottom - frm.Height : rct.Height = frm.Height
            Case ContentAlignment.BottomRight : rct.X = rct.Right - frm.Width : rct.Y = rct.Bottom - frm.Height : rct.Size = frm.Size
         End Select
         frm.Bounds = rct
      End Function

   End Module
End Namespace

